'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _withTheme = require('../styles/withTheme');

var _withTheme2 = _interopRequireDefault(_withTheme);

var _dom = require('../utils/dom');

var _dom2 = _interopRequireDefault(_dom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var document = _dom.canUseDom ? window.document : undefined;
// heavily inspired by https://github.com/Khan/react-components/blob/master/js/layered-component-mixin.jsx

var RenderToLayer = function (_Component) {
  (0, _inherits3.default)(RenderToLayer, _Component);

  function RenderToLayer(props) {
    (0, _classCallCheck3.default)(this, RenderToLayer);

    var _this = (0, _possibleConstructorReturn3.default)(this, (RenderToLayer.__proto__ || (0, _getPrototypeOf2.default)(RenderToLayer)).call(this, props));

    _this.state = { isOpen: false };

    _this.onClickAway = function (event) {
      if (!_dom.canUseDom || !document) {
        return;
      }

      if (event.defaultPrevented) {
        return;
      }

      if (!_this.props.componentClickAway) {
        return;
      }

      if (!_this.props.open) {
        return;
      }

      var el = _this.layer;
      if (event.target !== el && event.target === window || document.documentElement.contains(event.target) && !_dom2.default.isDescendant(el, event.target)) {
        _this.props.componentClickAway(event);
      }
    };

    _this.layer = { style: {} };
    if (!_dom.canUseDom) return (0, _possibleConstructorReturn3.default)(_this);
    if (!document) return (0, _possibleConstructorReturn3.default)(_this);
    _this.layer = document.createElement('div');
    document.body.appendChild(_this.layer);

    if (_this.props.useLayerForClickAway) {
      _this.layer.style.display = 'block';
      _this.layer.style.position = 'fixed';
      _this.layer.style.top = 0;
      _this.layer.style.bottom = 0;
      _this.layer.style.left = 0;
      _this.layer.style.right = 0;
      _this.layer.style.zIndex = _this.props.muiTheme.zIndex.layer;
    }
    return _this;
  }

  (0, _createClass3.default)(RenderToLayer, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.renderLayer();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (prevState.isOpen !== this.state.isOpen) this.renderLayer();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.unrenderLayer();
    }
  }, {
    key: 'getLayer',
    value: function getLayer() {
      return this.layer;
    }
  }, {
    key: 'unrenderLayer',
    value: function unrenderLayer() {
      this.setState({ isOpen: false });
    }

    /**
     * By calling this method in componentDidMount() and
     * componentDidUpdate(), you're effectively creating a "wormhole" that
     * funnels React's hierarchical updates through to a DOM node on an
     * entirely different part of the page.
     */

  }, {
    key: 'renderLayer',
    value: function renderLayer() {
      var _this2 = this;

      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props;
      var state = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.state;

      if (!_dom.canUseDom || !document) {
        return null;
      }
      if (state.isOpen) {
        if (props.useLayerForClickAway) {
          this.layer.style.position = 'fixed';
          this.layer.addEventListener('click', this.onClickAway);
        } else {
          setTimeout(function () {
            window.addEventListener('click', _this2.onClickAway);
          }, 100);
        }
        this.layer.style.display = 'block';
      } else {
        if (props.useLayerForClickAway) {
          this.layer.style.position = 'relative';
          this.layer.removeEventListener('click', this.onClickAway);
        } else {
          window.removeEventListener('click', this.onClickAway);
        }
        this.layer.style.display = 'none';
      }
    }
  }, {
    key: 'render',
    value: function render() {
      if (!_dom.canUseDom || !document || !this.layer || !this.state.isOpen) return null;
      var layerElement = this.props.render();
      return _reactDom2.default.createPortal(layerElement, this.layer);
    }
  }], [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (nextProps.open !== prevState.open) return { isOpen: nextProps.open };
      return null;
    }
  }]);
  return RenderToLayer;
}(_react.Component);

RenderToLayer.propTypes = {
  componentClickAway: _propTypes2.default.func,
  open: _propTypes2.default.bool.isRequired,
  render: _propTypes2.default.func.isRequired,
  useLayerForClickAway: _propTypes2.default.bool
};
RenderToLayer.defaultProps = {
  useLayerForClickAway: true
};
exports.default = (0, _withTheme2.default)(RenderToLayer);